//+------------------------------------------------------------------+
//|                                                  		 Traling.mq4 |
//|                                 Copyright  2007   |
//|                                                los@we.kherson.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,   "
#property link      "mailto: los@we.kherson.ua"
#property library

#include <Signals.mqh>

int LotDigit = 2; //   

double nMaxLot=100; //  ,     
double lastSL=100; //  ( ),     nMaxLot 

double SysPar[nSignal][11];
int _TP=0;//
int _NullTP = 1;//  ,      
int _NullTP2 = 2;//  ,      
int _TS = 3; //    
int _NullSL = 4;// ,         
int _SL = 5;// ,         
int _dSL = 6;//         
int _dStep=7; //    (   )       BuyLim
int _dLot=8; //   (   )     BuyLim 
int _nLot=9; //   (   )     BuyLim 

string SysParName[nSignal];

void InitSystemParam()
{
	ArrayInitialize(SysPar, 0.0);
	// 
	double TP=500.0;//
	double NullTP = 20.0;//  ,      
	double NullTP2 = 15.0;//  ,      
	double TS = 40.0; //    
	double NullSL = 20.0;// ,         
	double SL = 2000.0;// ,         
	double dSL = 50.0;//         
	double dStep=0.3; //    (   )       
	double dLot=2.0; //   (   )      
	double nLot=0.0; //   (   )     

//----    
   for(int i = 1; i <= nSignal; i++)
	{
		SysPar[i][_TP] = TP;
		SysPar[i][_NullTP] = NullTP;
		SysPar[i][_NullTP2] = NullTP2;
		SysPar[i][_TS] = TS;
		SysPar[i][_NullSL] = NullSL;
		SysPar[i][_SL] = SL;
		SysPar[i][_dSL] = dSL;
		SysPar[i][_dStep] = dStep;
		SysPar[i][_dLot] = dLot;
		SysPar[i][_nLot] = nLot;
		SysParName[i] = "";
	} 
}

int Ticket[1000];

int CountAllOrders(int dir, int SysID)
{
   int total=OrdersTotal(), i, c=0; if (total<=0) return (0);
	for(i=0;i<total;i++) { OrderSelect(i, SELECT_BY_POS);	if ((OrderType()==dir) && (OrderMagicNumber()==SysID)) {c=c+1;}	}
	return (c);
}

int CreatTicketArray(int dir, int SysID)
{
	int total=OrdersTotal(), i, c=1; if (total<=0) return (0);
	for(i=0;i<total;i++) { OrderSelect(i, SELECT_BY_POS); if ((OrderType()==dir) && (OrderMagicNumber()==SysID)) { Ticket[c] = OrderTicket(); c++; } }
	return (c-1);
}

void TrailingAvgStop(int SysID, color ClrBuy, color ClrSell)
{
	int i, total, pos;	
	double Profit, price, lots=0.0; 
	double m, m2, avgLevel;

	total = CreatTicketArray(OP_BUY, SysID); Profit=0.0;
	if (total>0) //  OP_BUY
	{//1.         dir
		for (i=1; i<=total; i++)  	{ 	OrderSelect(Ticket[i], SELECT_BY_TICKET); Profit = Profit+(Bid-OrderOpenPrice())*OrderLots();	}
		if (Profit>=0)
		{//    (,   +  -   ==0)
			m=0.0; m2=0.0; avgLevel=0.0;
			OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice(); m = OrderLots(); 
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET); m2 = OrderLots();	avgLevel = avgLevel-(m2*(avgLevel-OrderOpenPrice()))/(m2+m);	m = m+m2;}
			if (total>1) 
			{
				if ((Bid-avgLevel)>(SysPar[SysID][_NullTP2]*Point))//     
				{	for (i=1; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
						if (OrderStopLoss()<avgLevel) OrderModify(Ticket[i],0, avgLevel+1*Point, OrderTakeProfit(), 0, ClrBuy);
   				}
   			}
				for (i=1; i<=total; i++)//   
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
					if (OrderStopLoss()<Bid-(SysPar[SysID][_TS]+5)*Point && OrderStopLoss()>avgLevel)	OrderModify(Ticket[i],0,Bid-SysPar[SysID][_TS]*Point, OrderTakeProfit(),0,ClrBuy);
				}
			}
		}
	}	
	total = CreatTicketArray(OP_BUYSTOP, SysID);//    ?
	if (total<=0)//  ,        
	{//      ,      
		total = CreatTicketArray(OP_BUY, SysID);
		OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
		for (i=2; i<=total; i++)
		{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()<price)	{	price=OrderOpenPrice(); pos = i; }	}
		OrderSelect(Ticket[pos], SELECT_BY_TICKET);  lots = OrderLots()*2.0; 	lots = NormalizeDouble(lots, LotDigit);// 
		if (price>Ask+SysPar[SysID][_NullSL]*Point) 
			OrderSend(Symbol(), OP_BUYSTOP, lots, Ask+SysPar[SysID][_NullTP]*Point, 2, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrBuy);
	}
	else//             
	{		//    AvgLim    
		OrderSelect(Ticket[1], SELECT_BY_TICKET); 
		if (OrderOpenPrice()>Ask+(SysPar[SysID][_NullTP]+5)*Point)	OrderModify(Ticket[1], Ask+SysPar[SysID][_NullTP]*Point, OrderStopLoss(), OrderTakeProfit(), 0, ClrBuy);
	}

	total = CreatTicketArray(OP_SELL, SysID); Profit=0.0;
	if (total>0) //
	{//1.         dir
		for (i=1; i<=total; i++) { OrderSelect(Ticket[i], SELECT_BY_TICKET); Profit = Profit + (OrderOpenPrice()-Ask)*OrderLots();	}
		if (Profit>=0)
		{//    (,   +  -   =0)
			m=0.0; m2=0.0; avgLevel=0.0;
			OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice(); m = OrderLots(); 
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET); m2 = OrderLots();	avgLevel = avgLevel+(m2*(OrderOpenPrice()-avgLevel))/(m2+m); m = m+m2;	}
			if (total>1) 
			{
				if ((avgLevel-Ask)>(SysPar[SysID][_NullTP2]*Point)) //     
				{	for (i=1; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
						if (OrderStopLoss()>avgLevel) OrderModify(Ticket[i],0, avgLevel-1*Point, OrderTakeProfit(), 0, ClrSell);
   				}
   			}
				for (i=1; i<=total; i++) //   
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
					if (OrderStopLoss()>Ask+(SysPar[SysID][_TS]+5)*Point && OrderStopLoss()<avgLevel)	OrderModify(Ticket[i],0,Ask+SysPar[SysID][_TS]*Point, OrderTakeProfit(),0, ClrSell);
				}
			}
		}
	}
	total = CreatTicketArray(OP_SELLSTOP, SysID);//    ?
	if (total<=0)//  ,        
	{//      ,      
		total = CreatTicketArray(OP_SELL, SysID);
		OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
		for (i=2; i<=total; i++)
		{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()>price)	{	price=OrderOpenPrice(); pos = i; }	}
		OrderSelect(Ticket[pos], SELECT_BY_TICKET);  lots = OrderLots()*2.0; 	lots = NormalizeDouble(lots, LotDigit);// 
		if (price<Bid-SysPar[SysID][_NullSL]*Point) 
			OrderSend(Symbol(), OP_SELLSTOP, lots, Bid-SysPar[SysID][_NullTP]*Point, 2, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, SysParName[SysID], SysID, 0, ClrSell);
	}
	else//            
	{
		OrderSelect(Ticket[1], SELECT_BY_TICKET); 
		if (OrderOpenPrice()<Bid-(SysPar[SysID][_NullTP]+5)*Point) 
			OrderModify(Ticket[1], Bid-SysPar[SysID][_NullTP]*Point, OrderStopLoss(), OrderTakeProfit(), 0, ClrSell);
	}
}

void TrailingAvgLim(int SysID, color ClrBuy, color ClrSell)
{
	int i, total = OrdersTotal();	if (total<=0) return;
	double Profit, price, nTP=0.0; 
	int pos, pp;
	double m, m2, avgLevel, lots, lot1, newPrice, dSLPre;
	total = CreatTicketArray(OP_BUY, SysID); Profit=0.0;
	if (total>0) //  OP_BUY
	{//1.         dir
		for (i=1; i<=total; i++)  	{ 	OrderSelect(Ticket[i], SELECT_BY_TICKET); Profit = Profit+(Bid-OrderOpenPrice())*OrderLots();	}
		if (Profit>=0)
		{
			//    (,   +  -   =0)
			m=0.0; m2=0.0; avgLevel=0.0;
			OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice(); m = OrderLots(); 
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET); m2 = OrderLots();	avgLevel = avgLevel-(m2*(avgLevel-OrderOpenPrice()))/(m2+m);	m = m+m2;}

			if (total>1) 
			{
				if ((Bid-avgLevel)>(SysPar[SysID][_NullTP2]*Point))//     
				{	for (i=1; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
						if (OrderStopLoss()<avgLevel) OrderModify(Ticket[i],0, avgLevel+1*Point, OrderTakeProfit(), 0, ClrBuy);
   				}
   			}
				for (i=1; i<=total; i++)//   
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
					if ((Bid-OrderStopLoss())>(SysPar[SysID][_TS]*Point) && OrderStopLoss()>avgLevel)	OrderModify(Ticket[i],0,Bid-SysPar[SysID][_TS]*Point, OrderTakeProfit(),0,ClrBuy);
				}
			}
		}
		if (Profit<0)
		{
			if (total>=nMaxLot)//      
			{
				double newSL = 0.0;
				//      ,     
				OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
				for (i=2; i<=total; i++)
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()<price)	{	price=OrderOpenPrice(); pos = i; }	}
				OrderSelect(Ticket[pos], SELECT_BY_TICKET); newSL = OrderOpenPrice()-lastSL*Point;
				if (OrderStopLoss()!=newSL)
					for (i=1; i<=total; i++) {	OrderSelect(Ticket[i], SELECT_BY_TICKET);	OrderModify(Ticket[i],0,newSL,OrderTakeProfit(),0,ClrBuy);}
			}
			else
			{
				OrderSelect(Ticket[1], SELECT_BY_TICKET); 
				//     NullSL //    
//   			if ((total==1) && (OrderOpenPrice()-Bid>SysPar[SysID][_NullSL]*Point) && (OrderTakeProfit()>OrderOpenPrice())) 
//					OrderModify(Ticket[1],0,OrderStopLoss(),OrderOpenPrice(),0,ClrBuy);
				if (total>1)
				{
					avgLevel = OrderOpenPrice()+SysPar[SysID][_TP]*Point; 
					if (OrderTakeProfit()<avgLevel)
					{ for (i=1; i<=total; i++)  {	OrderSelect(Ticket[i], SELECT_BY_TICKET); OrderModify(Ticket[i],0,OrderStopLoss(), avgLevel, 0, ClrBuy); } }
				}
				i = CountAllOrders(OP_BUYLIMIT, SysID);
				if (i<=0) //3.          ,  
				{
					//4.     (    ),     
					OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
					for (i=2; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()>price)	{	price=OrderOpenPrice(); pos = i; }	}
					OrderSelect(Ticket[pos], SELECT_BY_TICKET); lot1 = OrderLots();
					//5.        ,     
					OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
					for (i=2; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()<price)	{	price=OrderOpenPrice(); pos = i; }	}
					//6.    
					OrderSelect(Ticket[pos], SELECT_BY_TICKET); lots = SysPar[SysID][_dLot]*OrderLots()+SysPar[SysID][_nLot]*lot1; 
					//7.         
					newPrice = OrderOpenPrice()- (SysPar[SysID][_dSL]+SysPar[SysID][_dStep]*SysPar[SysID][_dSL]*(total-1))*Point;
					newPrice = NormalizeDouble(newPrice, 4);
					//8.       newPrice    lots 
	         	lots = NormalizeDouble(lots, LotDigit); //    
					OrderSend(Symbol(), OP_BUYLIMIT, lots, newPrice, 3, OrderStopLoss(), OrderTakeProfit(), SysParName[SysID], SysID, 0, ClrBuy);
				}
			}
		}
	}//OP_BUY

	total = CreatTicketArray(OP_SELL, SysID); Profit=0.0;
	if (total>0) //
	{//1.         dir
		for (i=1; i<=total; i++) { OrderSelect(Ticket[i], SELECT_BY_TICKET); Profit = Profit + (OrderOpenPrice()-Ask)*OrderLots();	}
		if (Profit>=0)
		{//    (,   +  -   =0)
			m=0.0; m2=0.0; avgLevel=0.0;
			OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice(); m = OrderLots(); 
			for (i=2; i<=total; i++)
			{	OrderSelect(Ticket[i], SELECT_BY_TICKET); m2 = OrderLots();	avgLevel = avgLevel+(m2*(OrderOpenPrice()-avgLevel))/(m2+m); m = m+m2;	}
			
			if (total>1) 
			{
				if ((avgLevel-Ask)>(SysPar[SysID][_NullTP2]*Point)) //     
				{	for (i=1; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
						if (OrderStopLoss()>avgLevel) OrderModify(Ticket[i],0, avgLevel-1*Point, OrderTakeProfit(), 0, ClrSell);
   				}
   			}
				for (i=1; i<=total; i++) //   
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);
					if ((OrderStopLoss()-Ask)>(SysPar[SysID][_TS]*Point) && OrderStopLoss()<avgLevel)	OrderModify(Ticket[i],0,Ask+SysPar[SysID][_TS]*Point, OrderTakeProfit(),0, ClrSell);
				}
			}
		}
		if (Profit<0)
		{
			if (total>=nMaxLot)//      
			{
				//      ,     
				OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
				for (i=2; i<=total; i++)
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()>price)	{	price=OrderOpenPrice(); pos = i; }	}
				OrderSelect(Ticket[pos], SELECT_BY_TICKET); newSL = OrderOpenPrice()+lastSL*Point; 
				if (OrderStopLoss()!=newSL)
					for (i=1; i<=total; i++) {	OrderSelect(Ticket[i], SELECT_BY_TICKET);	OrderModify(Ticket[i],0,newSL,OrderTakeProfit(),0,ClrBuy);}
			}
			else
			{
				OrderSelect(Ticket[1], SELECT_BY_TICKET); 
				//     NullSL
// 			if ((total==1) && (Ask-OrderOpenPrice()>SysPar[SysID][_NullSL]*Point)	&& (OrderTakeProfit()<OrderOpenPrice())) 
//			OrderModify(Ticket[1],0,OrderStopLoss(),OrderOpenPrice(),0,ClrSell);
				if (total>1)
				{
					avgLevel = OrderOpenPrice()-SysPar[SysID][_TP]*Point;
					if (OrderTakeProfit()>avgLevel)
					{ for (i=1; i<=total; i++)  {	OrderSelect(Ticket[i], SELECT_BY_TICKET); OrderModify(Ticket[i],0,OrderStopLoss(), avgLevel, 0, ClrSell); } }
				}
				i = CountAllOrders(OP_SELLLIMIT, SysID);
				if (i<=0) //3.          ,  
				{
					OrderSelect(Ticket[1], SELECT_BY_TICKET); price=OrderOpenPrice(); pos = 1;
					for (i=2; i<=total; i++)
					{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()<price)	{	price=OrderOpenPrice(); pos = i; }	}
					OrderSelect(Ticket[pos], SELECT_BY_TICKET); lot1 = OrderLots();
   				OrderSelect(Ticket[1], SELECT_BY_TICKET);		price=OrderOpenPrice(); pos = 1;
					for (i=2; i<=total; i++)
   				{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	if (OrderOpenPrice()>price)	{	price=OrderOpenPrice(); pos = i; }	}
					OrderSelect(Ticket[pos], SELECT_BY_TICKET); lots = SysPar[SysID][_dLot]*OrderLots()+SysPar[SysID][_nLot]*lot1; 
					newPrice = OrderOpenPrice()+ (SysPar[SysID][_dSL]+SysPar[SysID][_dStep]*SysPar[SysID][_dSL]*(total-1))*Point;
					newPrice = NormalizeDouble(newPrice, 4);
	         	lots = NormalizeDouble(lots, LotDigit); //    
					OrderSend(Symbol(), OP_SELLLIMIT, lots, newPrice, 3, OrderStopLoss(), OrderTakeProfit(), SysParName[SysID], SysID, 0, ClrSell);
				}
			}
		}
	}//OP_SELL
	return;
}


void TrailingSimple(int SysID, color ClrBuy, color ClrSell)
{
   //     SL 
   int i, total = OrdersTotal();	if (total<=0) return;
	double Profit, price; 
	int n; bool b;
	double m, m2, avgLevel, lots, lot1, newPrice, dSLPre;
	total = CreatTicketArray(OP_BUY, SysID); Profit=0;
	if (total>0) //  OP_BUY
	{
		OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice();
		if (Bid-OrderOpenPrice()>=0)
		{
			//     
			if ((Bid-avgLevel)>(SysPar[SysID][_NullTP]*Point) && OrderStopLoss()<avgLevel) OrderModify(Ticket[1],0, avgLevel+1*Point, OrderTakeProfit(), 0, ClrBuy);
			//     +
			if ((Bid-OrderStopLoss())>(SysPar[SysID][_TS]*Point) && OrderStopLoss()>avgLevel) OrderModify(Ticket[1],0,Bid-SysPar[SysID][_TS]*Point, OrderTakeProfit(),0,ClrBuy);
		}
		else
		{
			//  SL  ,   
			if (OrderStopLoss()!=avgLevel-SysPar[SysID][_SL]*Point) OrderModify(Ticket[1],0,avgLevel-SysPar[SysID][_SL]*Point, OrderTakeProfit(),0,ClrBuy);
		}
	}//OP_BUY

	total = CreatTicketArray(OP_SELL, SysID); Profit=0;
	if (total>0) //
	{
		OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice();
		if (avgLevel-Ask>=0)
		{
			if ((avgLevel-Ask)>(SysPar[SysID][_NullTP]*Point) && (OrderStopLoss()>avgLevel)) OrderModify(Ticket[1],0, avgLevel-1*Point, OrderTakeProfit(), 0, ClrSell);
			if ((OrderStopLoss()-Ask)>(SysPar[SysID][_TS]*Point) && OrderStopLoss()<avgLevel)	OrderModify(Ticket[1],0,Ask+SysPar[SysID][_TS]*Point, OrderTakeProfit(),0, ClrSell);
		}
		else
			if (OrderStopLoss()!=avgLevel+SysPar[SysID][_SL]*Point) OrderModify(Ticket[1],0,avgLevel+SysPar[SysID][_SL]*Point, OrderTakeProfit(),0,ClrSell);
	}//OP_SELL
	return;
}

void TrailingMultiOpen(int SysID, color ClrBuy, color ClrSell)
{
   //     SL 
   int i, total = OrdersTotal();	if (total<=0) return;
	double ProfitBuy, ProfitSell, price; 
	int pos, pp;
	double m, m2, avgLevel, lots, lot1, newPrice, dSLPre;
	ProfitBuy=0.0; ProfitSell=0.0;
	total = CreatTicketArray(OP_BUY, SysID);
	//1.     
	if (total>0)
   	for (i=1; i<=total; i++)  	{ 	OrderSelect(Ticket[i], SELECT_BY_TICKET); ProfitBuy = ProfitBuy+(Bid-OrderOpenPrice());	}

	total = CreatTicketArray(OP_SELL, SysID);
	if (total>0)
		for (i=1; i<=total; i++)  	{ OrderSelect(Ticket[i], SELECT_BY_TICKET); ProfitSell = ProfitSell+(OrderOpenPrice()-Ask);	}

	if (ProfitBuy+ProfitSell>0)	
	{ CloseAllOrders(OP_BUY, SysID, ClrBuy, ClrSell); CloseAllOrders(OP_SELL, SysID, ClrBuy, ClrSell); }
	
	return;
}

void TryCloseAllOrders(int dir, int SysID, color ClrBuy, color ClrSell)
{
   //     SL      
   int i, total = OrdersTotal();	if (total<=0) return;
	int n; bool b;
	double Profit;
	if (dir == OP_BUY)
	{
		Profit=0; total = CreatTicketArray(OP_BUY, SysID); 	if (total<=0) return; //
   	//1.         dir
		for (i=1; i<=total; i++)  	{ 	OrderSelect(Ticket[i], SELECT_BY_TICKET);  	Profit = Profit + (Bid-OrderOpenPrice())*OrderLots();	}
   	//2.   +,        ( )
		if (Profit>=0)
		{	
			for (i=1; i<=total; i++)	{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	OrderClose(Ticket[i], OrderLots(), Bid, 3, ClrBuy); }
			total = CreatTicketArray(OP_BUYLIMIT, SysID);
			for (i=1; i<=total; i++)	{	OrderSelect(Ticket[i], SELECT_BY_TICKET); OrderDelete(Ticket[i], ClrBuy);	}
		}
	}//	if (dir == OP_BUY)
	if (dir == OP_SELL)
	{
		Profit=0; total = CreatTicketArray(OP_SELL, SysID); 	if (total<=0) return; //
		for (i=1; i<=total; i++)  	{ 	OrderSelect(Ticket[i], SELECT_BY_TICKET);  	Profit = Profit + (OrderOpenPrice()-Ask)*OrderLots();	}
		if (Profit>=0)
		{
			for (i=1; i<=total; i++)	{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	OrderClose(Ticket[i], OrderLots(), Ask, 3, ClrSell);	}
			total = CreatTicketArray(OP_SELLLIMIT, SysID);
			for (i=1; i<=total; i++)	{	OrderSelect(Ticket[i], SELECT_BY_TICKET); OrderDelete(Ticket[i], ClrSell);	}
		}
	}//	if (dir == OP_SELL)
   	
	return;
}

void CloseAllOrders(int dir, int SysID, color ClrBuy, color ClrSell)
{
   //     SL      
   int i, total = OrdersTotal();	if (total<=0) return;
	if (dir == OP_BUY)
	{
		total = CreatTicketArray(OP_BUY, SysID); 	if (total<=0) return; //
		for (i=1; i<=total; i++)	{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	OrderClose(Ticket[i], OrderLots(), Bid, 3, ClrBuy); }
	}//	if (dir == OP_BUY)
	if (dir == OP_SELL)
	{
		total = CreatTicketArray(OP_SELL, SysID); 	if (total<=0) return; //
		for (i=1; i<=total; i++)	{	OrderSelect(Ticket[i], SELECT_BY_TICKET);	OrderClose(Ticket[i], OrderLots(), Ask, 3, ClrSell);	}
	}//	if (dir == OP_SELL)
   	
	return;
}


